/* Compile with MS C 6.00 */

#include <stdio.h>
#include <graph.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>

#define	PI	3.14159265

#define	CX	640
#define	CY	480

/*...smv\44\ ln\44\ pt:0:*/
static short xc(double t)
	{
	return ( (short) (t / 30.0 * (double) CX) );
	}

static short yc(double v)
	{
	return ( CY / 2.0 - (short) (v * (double) CY / 2.0) );
	}

static void mv(double t, double v)
	{
	_moveto(xc(t),yc(v));
	}

static void ln(double t, double v)
	{
	_lineto(xc(t),yc(v));
	}

static void pt(double t, double v)
	{
	short x = xc(t);
	short y = yc(v);
	short xmin = max(0   , x - 3);
	short xmax = min(CX-1, x + 3);
	short ymin = max(0   , y - 3);
	short ymax = min(CY-1, y + 3);

	_moveto(xmin,y); _lineto(xmax,y);
	_moveto(x,ymin); _lineto(x,ymax);
	}
/*...e*/
/*...slin_interp:0:*/
static double lin_interp(
	double x1, double y1,
	double x2, double y2,
	double x
	)
	{
	return ( y1 + ( (x - x1) * (y2 - y1) / (x2 - x1) ) );
	}
/*...e*/

void main(void)
	{
	int frame;

	_setvideomode(_VRES16COLOR); /* 640x480, 16 color */

	_clearscreen(_GCLEARSCREEN);
	_setcolor(7); /* White */
	mv(0.0, 0.0); ln(10.0, 0.0);
	mv(0.0,-1.0); ln( 0.0, 1.0);

	for ( frame = 0; frame < 30; frame++ )
		{
		double t = (double) frame;
		double theta, phi, x, y, z, vz;
		char fn [100+1];
		FILE *fp;

		sprintf(fn, "toff_%03d.rt", frame);
		if ( (fp = fopen(fn, "w")) == NULL )
			exit(1);

		if ( t <= 5 )
			theta = 0.0;
		else if ( t <= 15 )
			theta = lin_interp(5.0,0.0,15.0,-90.0,t);
		else
			theta = -90.0;

		if ( t <= 5 )
			phi = 0.0;
		else if ( t <= 15 )
			phi = lin_interp(5.0,0.0,15.0,-70.0,t);
		else
			phi = -70.0;

		_setcolor(14); /* Yellow */
		pt(t, theta/90.0);
		_setcolor(5); /* Magenta */
		pt(t, phi/90.0);

		fprintf(fp, "set_value theta rad(%lf)\n", theta);
		fprintf(fp, "set_value phi   rad(%lf)\n", phi  );

		if ( t <= 15 )
			x = 0;
		else
			x = lin_interp(15,0.0,30.0,25.0, t);

		if ( t <= 10 )
			y = lin_interp(0.0,0.0,10.0,5.0,t);
		else
			y = 5.0;

		if ( t <= 15 )
			z = 0.0;
		else
			{
			double tan70 = tan(70.0/180.0*3.1415);
			z = lin_interp(15.0,0.0,30.0,25.0*tan70, t);
			}

		_setcolor(4); /* Red */
		pt(t, x/50.0);
		_setcolor(1);
		pt(t, y/50.0);
		_setcolor(2);
		pt(t, z/50.0);

		fprintf(fp, "set_value x %lf\n", x);
		fprintf(fp, "set_value y %lf\n", y);
		fprintf(fp, "set_value z %lf\n", z);

		vz = lin_interp(0.0,45.0,30.0,55.0,t);

		_setcolor(7); /* White */
		pt(t, vz/100.0);

		fprintf(fp, "set_value vz %lf\n", vz);

		fprintf(fp, "include \"toff1.rt\"\n");
		fprintf(fp, "render r e f u ax ay cx cy d t \"toff_%03d.tif,lzw\"\n", frame);
		fclose(fp);
		}

	getch();
	_setvideomode(_DEFAULTMODE);
	}
